#include <amxmodx>
#include <amxmisc>
#include <fakemeta>

#define FIRST_TASK			1615124
#define SECOND_TASK			2454621
#define THIRD_TASK			3656432
#define ENDDOSE_TASK		4764645
#define ENDOVERDOSE_TASK	5456774
#define ENDED_TASK			6345625
#define SHOW_TASK			7236521
#define SND_TASK			8347214
#define OFFSET_CSMONEY		115

new c_Mod, g_Mod
new c_Amount, Float:g_Amount
new c_Count, g_Count
new c_Cost, g_Cost
new c_Team, g_Team
new c_Buyzone, g_Buyzone
new bool:g_bBuyZone[33]
new bool:g_hweap[33]
new g_Nomore[33]
new g_PurchasedHP[33]
new g_iMsgFade, g_iMsgMoney, g_iMsgStatusIcon

new BuySound[] = "items/gunpickup2.wav"
new UseSound[] = "items/smallmedkit2.wav"
new OverdoseSound[] = "player/gasp1.wav"

public plugin_init() 
{
	register_plugin("Preparation", "1.39", "se7h")
	
	c_Mod = register_cvar("amx_preparation","1")
	c_Amount = register_cvar("p_amount","30")
	c_Count = register_cvar("p_limit","3")
	c_Cost = register_cvar("p_cost","1500")
	c_Team = register_cvar("p_team", "0")
	c_Buyzone = register_cvar("p_buyzone", "1")

	register_clcmd("buy_hp","cmd_buy")
	register_clcmd("use_hp","cmd_use")

	register_event("HLTV", "new_round", "a", "1=0", "2=0")
	register_event("DeathMsg","deathmsg","a")
	register_event( "StatusIcon", "buyzone", "be", "2=buyzone" )

	register_forward(FM_PlayerPreThink,"fw_prethink")
	
	g_iMsgStatusIcon = get_user_msgid("StatusIcon")
	g_iMsgMoney = get_user_msgid("Money")
	g_iMsgFade = get_user_msgid("ScreenFade")
}

public plugin_cfg()
{
	read_settings()
}

public plugin_precache()
{
	precache_sound(BuySound)
	precache_sound(UseSound)
	precache_sound(OverdoseSound)
}

public read_settings()
{
	g_Mod = get_pcvar_num(c_Mod)
	g_Amount = get_pcvar_float(c_Amount)
	g_Count = get_pcvar_num(c_Count)
	g_Cost = get_pcvar_num(c_Cost)
	g_Team = get_pcvar_num(c_Team)
	g_Buyzone = get_pcvar_num(c_Buyzone)
}

public fw_prethink(id)
{
	if(!g_Mod)
		return FMRES_IGNORED

	if(!is_user_alive(id))
		return FMRES_IGNORED

	switch(g_Nomore[id])
	{
		case 0:
		{
			if(g_PurchasedHP[id])
			{
				message_begin(MSG_ONE,g_iMsgStatusIcon,_,id)
				write_byte(1)
				write_string("dmg_bio")
				write_byte(0)
				write_byte(160)
				write_byte(0)
				message_end()
			}
		}
		case 1:
		{
			message_begin(MSG_ONE,g_iMsgStatusIcon,_,id)
			write_byte(1)
			write_string("dmg_bio")
			write_byte(160)
			write_byte(160)
			write_byte(0)
			message_end()
		}
		case 2:
		{
			message_begin(MSG_ONE,g_iMsgStatusIcon,_,id)
			write_byte(1)
			write_string("dmg_bio")
			write_byte(160)
			write_byte(0)
			write_byte(0)
			message_end()
		}
		case 3:
		{
			message_begin(MSG_ONE,g_iMsgStatusIcon,_,id)
			write_byte(2)
			write_string("dmg_bio")
			write_byte(0)
			write_byte(0)
			write_byte(0)
			message_end()
		}
	}

	if(g_hweap[id])
		set_pev(id, pev_button, (pev(id, pev_button) & ~(IN_ATTACK | IN_ATTACK2)))

	return FMRES_IGNORED
}  


public client_connect(id)
{
	g_hweap[id] = false
	g_PurchasedHP[id]=0
	g_Nomore[id] = 0
	stoptasks(id)
}

public buyzone(id)
{
	if(read_data(1))
		g_bBuyZone[id] = true
	else{
		if(g_Buyzone)
			g_bBuyZone[id] = false
		else
			g_bBuyZone[id] = true
	}
}

public cmd_buy(id)
{
	if(!g_Mod)
		return PLUGIN_HANDLED

	if(!is_user_alive(id))
		return PLUGIN_HANDLED

	if(g_Team)
	{
		if(get_user_team(id)!=g_Team)
		{
			client_print( id, print_center, "Your team cannot buy preparation!")
			return PLUGIN_HANDLED
		}
	}

	if(!g_bBuyZone[id])
	{
		client_print( id, print_center, "You must be in a buyzone to purchase that item!")
		return PLUGIN_HANDLED
	}

	if(fm_get_user_money(id)>=g_Cost)
	{
		if(g_PurchasedHP[id]<=g_Count)
		{
			g_PurchasedHP[id]++
			emit_sound(id,CHAN_AUTO,BuySound,0.9,ATTN_NORM,0,PITCH_NORM)
			fm_set_user_money(id, fm_get_user_money(id)-g_Cost)
			if (g_Count!=0)
				client_print(id,print_center,"You have got [%d] of [%d] doses of a preparation!",g_PurchasedHP[id],g_Count)
			else
				client_print(id,print_center,"You have got [%d] doses of a preparation!",g_PurchasedHP[id])
		}else
			client_print(id,print_center,"You can't carry anymore!")
	}else
		client_print(id,print_center,"You have insufficient funds!")

	return PLUGIN_HANDLED
}

public cmd_use(id)
{
	if(!g_Mod)
		return PLUGIN_HANDLED

	if(!is_user_alive(id))
		return PLUGIN_HANDLED

	if(g_Team)
	{
		if(get_user_team(id)!=g_Team)
		{
			client_print( id, print_center, "Your team cannot use preparation!")
			return PLUGIN_HANDLED
		}
	}

	if(!g_PurchasedHP[id])
	{
		client_print(id,print_center,"You have no doses left")

		return PLUGIN_HANDLED
	}

	static Float:health
	pev(id, pev_health, health)
	if(health==100.0)
	{
		client_print(id,print_center,"You already have full HP")

		return PLUGIN_HANDLED
	}

	hideweapon(id)
	set_task(1.0,"emitsound",SND_TASK+id)
	set_task(2.0,"showweapon",SHOW_TASK+id)

	switch(g_Nomore[id])
	{
		case 0:
		{
			g_Nomore[id] = 1
			g_PurchasedHP[id]--
		
			client_print(id,print_center,"You have [%d] doses left",g_PurchasedHP[id])
		
			set_task(3.0,"first",FIRST_TASK+id)
			set_task(3.0*g_Amount,"endoverdose",ENDOVERDOSE_TASK+id)
		}
		case 1:
		{
			g_Nomore[id] = 2
			g_PurchasedHP[id]--
			client_print(id,print_center,"You have [%d] doses left",g_PurchasedHP[id])

			if(task_exists(FIRST_TASK+id))
				remove_task(FIRST_TASK+id)

			if(task_exists(ENDOVERDOSE_TASK+id))
				remove_task(ENDOVERDOSE_TASK+id)

			set_task(5.0,"second",SECOND_TASK+id)
			set_task(4.0*g_Amount,"enddose",ENDDOSE_TASK+id)
		}
		case 2:
		{
			g_Nomore[id] = 3
			g_PurchasedHP[id]--
			client_print(id,print_center,"You have overdose!")

			if(task_exists(SECOND_TASK+id))
				remove_task(SECOND_TASK+id)

			if(task_exists(ENDDOSE_TASK+id))
				remove_task(ENDDOSE_TASK+id)

			set_task(7.0,"third",THIRD_TASK+id)
		}
	}

	return PLUGIN_HANDLED
}

public first(TASK1)
{
	static id 
	id = TASK1 - FIRST_TASK

	if(is_user_alive(id))
	{
		static Float:new_hp, Float:old_hp
		pev(id, pev_health, old_hp)
		new_hp = old_hp+g_Amount

		if (new_hp>100.0)
			set_pev(id, pev_health, 100.0)
		else
			set_pev(id, pev_health, new_hp)

		message_begin(MSG_ONE, g_iMsgFade, _, id)
		write_short(1<<300)
		write_short(1<<200)
		write_short(1<<12)
		write_byte(100)
		write_byte(200)
		write_byte(100)
		write_byte(150)
		message_end()

		set_task(2.0*g_Amount,"ended",ENDED_TASK+id)
	}
}

public second(TASK2)
{
	static id
	id = TASK2 - SECOND_TASK

	if(is_user_alive(id))
	{
		static Float:dose_hp, Float:old_hp
		pev(id, pev_health, old_hp)
		dose_hp = old_hp+g_Amount/2.0

		if(dose_hp>100.0)
			set_pev(id, pev_health, 100.0)
		else
			set_pev(id, pev_health, dose_hp)

		message_begin(MSG_ONE, g_iMsgFade, _, id)
		write_short(1<<300)
		write_short(1<<200)
		write_short(1<<12)
		write_byte(200)
		write_byte(100)
		write_byte(200)
		write_byte(150)
		message_end()

		set_task(1.5*g_Amount,"ended",ENDED_TASK+id)
	}
}

public third(TASK3)
{
	static id
	id = TASK3 - THIRD_TASK

	if(is_user_alive(id))
	{
		user_kill(id, 0)

		message_begin(MSG_ONE, g_iMsgFade, _, id)
		write_short(1<<300)
		write_short(1<<200)
		write_short(1<<12)
		write_byte(200)
		write_byte(0)
		write_byte(0)
		write_byte(150)
		message_end()
	}
}

public enddose(TASK4)
{
	static id
	id = TASK4 - ENDDOSE_TASK

	if(is_user_alive(id) && g_Nomore[id]!=3)
	{
		g_Nomore[id] = 1

		client_print(id,print_center,"You can apply a preparation once")

		set_task(3.0*g_Amount,"endoverdose",ENDOVERDOSE_TASK+id)
	}
}

public endoverdose(TASK5)
{
	static id
	id = TASK5 - ENDOVERDOSE_TASK

	if(is_user_alive(id))
	{
		g_Nomore[id] = 0

		client_print(id,print_center,"You can apply a preparation two times")
	}
}

public ended(TASK6)
{
	static id
	id = TASK6 - ENDED_TASK

	if(is_user_alive(id))
	{
		static Float:old_hp
		pev(id, pev_health, old_hp)
		if(!g_Nomore[id])
			set_pev(id, pev_health, old_hp/2.0)
		else
			set_pev(id, pev_health, old_hp/3.0)

		if(old_hp<1.0)
			user_kill(id, 0)

		message_begin(MSG_ONE, g_iMsgFade, _, id)
		write_short(1<<300)
		write_short(1<<150)
		write_short(1<<12)
		write_byte(100)
		write_byte(0)
		write_byte(0)
		write_byte(150)
		message_end()

		client_print(id,print_center,"Preparation action is ended")
	}
}

public emitsound(TASK8)
{
	static id
	id = TASK8-SND_TASK

	emit_sound(id,CHAN_AUTO,UseSound,0.9,ATTN_NORM,0,PITCH_NORM)

	if(task_exists(THIRD_TASK+id))
		emit_sound(id,CHAN_AUTO,OverdoseSound,0.9,ATTN_NORM,0,PITCH_NORM)
}

public showweapon(TASK7)
{
	static id
	id=TASK7-SHOW_TASK

	g_hweap[id] = false
	engclient_cmd(id, "lastinv")
	engclient_cmd(id, "lastinv")
}

hideweapon(id)
{
	g_hweap[id] = true
	set_pev(id, pev_viewmodel, "")
	set_pev(id, pev_weaponmodel, "")
}

public new_round()
{
	arrayset(g_Nomore, 0, sizeof g_Nomore)
	arrayset(g_hweap, false, sizeof g_hweap)
	client_cmd(0, "lastinv; lastinv")

	static players[32], num, i
	get_players(players, num, "h") 
	for(i=0; i<num; i++)
		stoptasks(players[i])
}

public deathmsg()
{
	static id
	id = read_data(2)

	g_PurchasedHP[id]=0
	g_Nomore[id]=0
	g_hweap[id]=false
	client_cmd(id, "lastinv; lastinv")

	message_begin(MSG_ONE,g_iMsgStatusIcon,_,id)
	write_byte(0)
	write_string("dmg_bio")
	write_byte(0)
	write_byte(0)
	write_byte(0)
	message_end()

	stoptasks(id)
}

stock stoptasks(id)
{
	if(task_exists(FIRST_TASK+id))
		remove_task(FIRST_TASK+id)
	if(task_exists(SECOND_TASK+id))
		remove_task(SECOND_TASK+id)
	if(task_exists(THIRD_TASK+id))
		remove_task(THIRD_TASK+id)
	if(task_exists(ENDDOSE_TASK+id))
		remove_task(ENDDOSE_TASK+id)
	if(task_exists(ENDOVERDOSE_TASK+id))
		remove_task(ENDOVERDOSE_TASK+id)
	if(task_exists(ENDED_TASK+id))
		remove_task(ENDED_TASK+id)
	if(task_exists(SHOW_TASK+id))
		remove_task(SHOW_TASK+id)
	if(task_exists(SND_TASK+id))
		remove_task(SND_TASK+id)
}

stock fm_get_user_money(index)
{
	return get_pdata_int(index, OFFSET_CSMONEY);
}

stock fm_set_user_money(index, money, flash = 1)
{
	set_pdata_int(index, OFFSET_CSMONEY, money);
	
	message_begin(MSG_ONE, g_iMsgMoney, _, index);
	write_long(money);
	write_byte(flash ? 1 : 0);
	message_end();
}
